require 'spec_helper'

describe 'splunk::install', :type => :class do
  describe "Splunk install private sub class" do
    describe "on RedHat platform" do
      let(:facts) { { :osfamily => 'RedHat' } }
      let(:params) { {
        :pkgname          => 'splunk',
        :splunkadmin      => ':admin:$6$lMfswwNUJguIpdCg$4NjqyHYy3JxA7.LHkgFZzm8LFr8BN5pTnIrYLi1PcTuXoIrSXNLVQDOnGfvuCr3lfrWCRNRR/Mf5gC4f9VTmS.::Administrator:admin:changeme@example.com:',
        :splunkhome       => '/opt/splunk',
        :type             => 'search',
        :version          => 'installed',
        :replace_passwd   => 'no'
      } }

      it { should create_class('splunk::install') }
      it { 
        should contain_file('/opt/splunk/etc/passwd').with(
          'ensure'  => 'present',
          'owner'   => 'root',
          'group'   => 'root',
          'mode'    => '0600',
          'backup'  => 'true',
          'replace' => 'no'
        )
      }
      it { should contain_file('/opt/splunk/etc/passwd').with_content(":admin:$6$lMfswwNUJguIpdCg$4NjqyHYy3JxA7.LHkgFZzm8LFr8BN5pTnIrYLi1PcTuXoIrSXNLVQDOnGfvuCr3lfrWCRNRR/Mf5gC4f9VTmS.::Administrator:admin:changeme@example.com:\n") }
      #it { should contain_file('/opt/splunk/etc/system/local/outputs.conf').with_content(/defaultGroup = example1/) }
      #it { should contain_file('/opt/splunk/etc/system/local/outputs.conf').with_content(/disabled = false/) }
      #it { should contain_file('/opt/splunk/etc/system/local/outputs.conf').with_content(/tcpout:example1/) }
      it {
        should contain_file('/opt/splunk/etc/splunk.license').with(
          'ensure'  => 'present',
          'owner'   => 'splunk',
          'group'   => 'splunk',
          'mode'    => '0644',
          'backup'  => 'true',
        )
      }
    end
  end
end
